<?php

declare(strict_types=1);

namespace Evidente\Aircash\Api;

use Evidente\Aircash\Api\Data\Transaction\CancellationRequestInterface;
use Evidente\Aircash\Api\Data\Transaction\CancellationResultInterface;
use Evidente\Aircash\Api\Data\Transaction\CodeRequestInterface;
use Evidente\Aircash\Api\Data\Transaction\CodeResultInterface;
use Evidente\Aircash\Api\Data\Transaction\RefundRequestInterface;
use Evidente\Aircash\Api\Data\Transaction\RefundResultInterface;
use Evidente\Aircash\Exception\RequestException;

interface AircashClientInterface
{
    public const BASE_URI = 'api/AircashPay/';
    public const GENERATE_PARTNER_CODE_URI = self::BASE_URI . 'GeneratePartnerCode';
    public const CANCEL_TRANSACTION_URI = self::BASE_URI . 'CancelTransaction';
    public const REFUND_TRANSACTION_URI = self::BASE_URI . 'RefundTransaction';

    /**
     * @throws RequestException
     */
    public function getTransactionCode(CodeRequestInterface $request): CodeResultInterface;

    /**
     * @throws RequestException
     */
    public function cancelTransaction(CancellationRequestInterface $request): CancellationResultInterface;

    /**
     * @throws RequestException
     */
    public function refundTransaction(RefundRequestInterface $request): RefundResultInterface;
}
