<?php

declare(strict_types=1);

namespace Evidente\Aircash\Api;

use Evidente\Aircash\Api\Data\Partner\ActivationRequestInterface;
use Evidente\Aircash\Exception\RequestException;

interface AircashPartnerClientInterface
{
    public const BASE_URI = 'api/AircashPay/';
    public const ACTIVATE_PARTNER_URI = self::BASE_URI . 'ActivatePartner';
    public const CHECK_PARTNER_URI = self::BASE_URI . 'CheckPartner';

    /**
     * @throws RequestException
     */
    public function activatePartner(ActivationRequestInterface $request): void;

    /**
     * @throws RequestException
     */
    public function checkPartner(string $partnerId): int;
}
