<?php

declare(strict_types=1);

namespace Evidente\Aircash\Api;

interface ConfigInterface
{
    public const DEV_BASE_URL = 'http://fakeaircashserver.local/';
    public const TEST_BASE_URL = 'https://staging-m3.aircash.eu/';
    public const PROD_BASE_URL = 'https://m3.aircash.eu/';

    public const CONFIG_GROUP_TEST = 'test';
    public const CONFIG_GROUP_PROD = 'production';

    public const CONFIG_PATH_BASE = 'payment/aircash/';
    public const CONFIG_PATH_TITLE = 'title';
    public const CONFIG_PATH_ACTIVE = 'active';
    public const CONFIG_PATH_TEST_MODE = 'test_mode';
    public const CONFIG_PATH_DEVELOPER_MODE = 'developer_mode';
    public const CONFIG_PATH_PARTNER_STATUS = 'partner_status';
    public const CONFIG_PATH_TRANSACTION_ID_PREFIX = 'transaction_id_prefix';
    public const CONFIG_PATH_PARTNER_ID = 'partner_id';
    public const CONFIG_PATH_LOCATION_ID = 'location_id';
    public const CONFIG_PATH_PARTNER_CURRENCY = 'partner_currency_code';
    public const CONFIG_PRIVATE_KEY = 'private_key';
    public const CONFIG_PASSPHRASE = 'passphrase';

    /**
     * @param int|string|null $storeId
     * @return mixed
     */
    public function getTitle($storeId = null);

    public function isActive($storeId = null): bool;

    public function isTestMode($websiteId = null): bool;

    public function isDeveloperMode($storeId = null): bool;

    /**
     * @return mixed
     */
    public function getPartnerStatus($websiteId = null);

    /**
     * @return mixed
     */
    public function getTransactionIdPrefix($websiteId = null);

    public function getPartnerID($websiteId = null): string;

    public function getLocationID($websiteId = null): string;

    public function getPartnerCurrency($websiteId = null): string;

    /**
     * @return mixed
     */
    public function getPublicKey($websiteId = null);

    /**
     * @return mixed
     */
    public function getPrivateKey($websiteId = null);

    /**
     * @return mixed
     */
    public function getPassphrase($websiteId = null);
}
