<?php

declare(strict_types=1);

namespace Evidente\Aircash\Api\Data\Partner;

use Evidente\Aircash\Api\WebsiteAwareInterface;

interface ActivationRequestInterface extends WebsiteAwareInterface
{
    public const STATUS_NOT_ACTIVATED = -1;
    public const STATUS_PENDING = 0;
    public const STATUS_ACTIVATED = 1;
    public const STATUS_REJECTED = 2;

    public const STATUS_LABELS = [
        self::STATUS_NOT_ACTIVATED => 'Not Activated',
        self::STATUS_PENDING => 'Pending Activation',
        self::STATUS_ACTIVATED => 'Activated',
        self::STATUS_REJECTED => 'Activation Rejected'
    ];

    public function getPlatformID(): string;

    public function getPartnerID(): string;

    public function getPartnerName(): string;

    public function getPublicKey(): string;

    public function getCurrencyID(): int;

    public function getConfirmTransactionURL(): string;

    public function getContactEmail(): string;

    public function getPhoneNumber(): string;

    public function getNote(): ?string;

    public function toArray(): array;
}
