<?php

declare(strict_types=1);

namespace Evidente\Aircash\Api\Factory\Partner;

use Evidente\Aircash\Api\Data\Partner\ActivationRequestInterface;
use Evidente\Aircash\Exception\InvalidInputException;
use Magento\Framework\Exception\NoSuchEntityException;

interface ActivationRequestFactoryInterface
{
    public const PLATFORM_ID = '39593540-eda4-4fe8-89a0-aff68c6b36d7';

    /**
     * @throws InvalidInputException
     * @throws NoSuchEntityException
     */
    public function create(
        int $websiteId,
        string $partnerName,
        string $publicKey,
        string $contactEmail,
        string $phoneNumber,
        ?string $note = null
    ): ActivationRequestInterface;
}
