<?php

declare(strict_types=1);

namespace Evidente\Aircash\Api\Rest;

use Evidente\Aircash\Api\Data\Transaction\CodeRequestInterface;
use Evidente\Aircash\Api\Data\Transaction\CodeResultInterface;
use Evidente\Aircash\Exception\PaymentExpiredException;
use Magento\Framework\Exception\LocalizedException;

interface CheckoutDataProviderInterface
{
    public const PAYMENT_FIELD_EXPIRES = 'aircash_payment_expires';

    /**
     * @return CodeRequestInterface|null
     */
    public function getLastCodeRequest(): ?CodeRequestInterface;

    /**
     * @return CodeResultInterface
     * @throws PaymentExpiredException
     * @throws LocalizedException
     */
    public function getCode(): CodeResultInterface;
}
