<?php

declare(strict_types=1);

namespace Evidente\Aircash\Api;

use Evidente\Aircash\Exception\InvalidSignatureException;

interface SignatureInterface
{
    /**
     * @param mixed $privateKey
     */
    public function sign(array $input, $privateKey, ?string $passphrase = null): string;

    /**
     * @param mixed $publicKey
     * @throws InvalidSignatureException
     */
    public function validate(array $input, string $givenSignature, $publicKey): void;
}
