<?php

declare(strict_types=1);

namespace Evidente\Aircash\Block\Adminhtml;

use Magento\Backend\Block\Template;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Exception\NoSuchEntityException;
use Magento\Store\Model\ScopeInterface;

/**
 * @SuppressWarnings(CamelCase)
 */
class ActivationBlock extends Template
{
    /**
     * @return string
     * @throws NoSuchEntityException
     * @throws LocalizedException
     */
    public function getStoreName()
    {
        $websiteId = (int)$this->getRequest()->getParam('website');
        return $this->escapeHtml($this->_storeManager->getWebsite($websiteId)->getName());
    }

    public function getStoreEmail()
    {
        $websiteId = (int)$this->getRequest()->getParam('website');

        return $this->escapeHtml(
            $this->_scopeConfig->getValue(
                'trans_email/ident_sales/email',
                ScopeInterface::SCOPE_WEBSITE,
                $websiteId
            )
        );
    }

    public function getStorePhone()
    {
        $websiteId = (int)$this->getRequest()->getParam('website');

        return $this->escapeHtml(
            $this->_scopeConfig->getValue(
                'general/store_information/phone',
                ScopeInterface::SCOPE_WEBSITE,
                $websiteId
            )
        );
    }
}
