<?php

declare(strict_types=1);

namespace Evidente\Aircash\Block\Adminhtml\System\Config\Form;

use Magento\Framework\Data\Form\Element\AbstractElement;

trait FieldContextTrait
{
    private function getFieldContext(AbstractElement $element): array
    {
        $websiteId = (int)$this->getRequest()->getParam('website');

        $path = explode('/', $element->getDataByPath('field_config/path'));
        $testMode = end($path) === 'test';

        return [$websiteId, $testMode];
    }

    /**
     * @SuppressWarnings(Boolean)
     */
    private function getFakeInput($html, bool $disabled = true): string
    {
        if ($html === null || empty($html)) {
            $html = '&nbsp;';
        }

        $style = 'border: 1px solid #adadad; display: block; padding: 6px;';

        if ($disabled) {
            $style .= 'background-color: #e9e9e9;';
        }

        return "<span style='$style'>"
            . $html
            . '</span>';
    }
}
