<?php

declare(strict_types=1);

namespace Evidente\Aircash\Block\Adminhtml\System\Config\Form;

use Evidente\Aircash\Model\Config\PartnerConfig;
use Magento\Config\Block\System\Config\Form\Field;
use Magento\Framework\Data\Form\Element\AbstractElement;
use Magento\Backend\Block\Template\Context;

/**
 * @SuppressWarnings(CamelCase)
 */
class PartnerIdField extends Field
{
    use FieldContextTrait;

    /**
     * @var PartnerConfig
     */
    private $partnerConfig;

    /**
     * @inheritDoc
     */
    public function __construct(Context $context, PartnerConfig $partnerConfig, array $data = [])
    {
        parent::__construct($context, $data);
        $this->partnerConfig = $partnerConfig;
    }

    // phpcs:ignore
    protected function _getElementHtml(AbstractElement $element)
    {
        list($websiteId, $testMode) = $this->getFieldContext($element);

        $value = $this->partnerConfig->getPartnerId($websiteId, $testMode);

        return $this->getFakeInput($value);
    }
}
