<?php

namespace Evidente\Aircash\Block\Info;

use Magento\Framework\Locale\Resolver;
use Magento\Framework\View\Element\Template;
use Magento\Payment\Block\Info;

/**
 * @codeCoverageIgnore
 */
class Aircash extends Info
{
    /**
     * @var Resolver
     */
    private $locale;

    public function __construct(
        Template\Context $context,
        Resolver $locale,
        array $data = []
    ) {
        parent::__construct($context, $data);

        $this->_template = 'Evidente_Aircash::payment/info.phtml';

        $this->locale = $locale;
    }

    /**
     * @return string|null
     */
    public function getLocale()
    {
        return $this->locale->getLocale();
    }

    /**
     * @param string $string
     * @return bool
     */
    public function isStringUrl($string)
    {
        return (bool)filter_var($string, FILTER_VALIDATE_URL);
    }
}
