<?php

declare(strict_types=1);

namespace Evidente\Aircash\Controller\Adminhtml\Activation;

use Evidente\Aircash\Facade\PartnerCheckFacade;
use Magento\Backend\App\Action;
use Magento\Framework\App\Action\HttpGetActionInterface;

class Status extends Action implements HttpGetActionInterface
{
    const ADMIN_RESOURCE = 'Evidente_Aircash::aircash_activation';

    /**
     * @var PartnerCheckFacade
     */
    private $partnerCheckFacade;

    /**
     * @inheritDoc
     */
    public function __construct(Action\Context $context, PartnerCheckFacade $partnerCheckFacade)
    {
        parent::__construct($context);
        $this->partnerCheckFacade = $partnerCheckFacade;
    }

    /**
     * @inheritDoc
     */
    public function execute()
    {
        $websiteId = (int)$this->getRequest()->getParam('website');
        $testMode = (bool)$this->getRequest()->getParam('test');

        list($message, $error) = $this
            ->partnerCheckFacade
            ->check($testMode, $websiteId);

        $messageManager = $this->getMessageManager();

        if ($error) {
            $messageManager->addErrorMessage($error);
        }

        if ($message) {
            $messageManager->addSuccessMessage($message);
        }

        return $this->_redirect($this->_redirect->getRefererUrl());
    }
}
