<?php

declare(strict_types=1);

namespace Evidente\Aircash\Controller\Checkout;

use Magento\Checkout\Model\SessionFactory;
use Magento\Checkout\Model\Session;
use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\ActionInterface;

/**
 * @SuppressWarnings(Long)
 */
class Expired extends Action implements ActionInterface
{
    /**
     * @var SessionFactory
     */
    private $sessionFactory;

    /**
     * @inheritDoc
     */
    public function __construct(
        Context $context,
        SessionFactory $sessionFactory
    ) {
        parent::__construct($context);
        $this->sessionFactory = $sessionFactory;
    }

    /**
     * @inheritDoc
     * @SuppressWarnings(Else)
     */
    public function execute()
    {
        /**
         * @var Session
         */
        $session = $this->sessionFactory->create();

        $placedOrderId = $session->getLastOrderId();

        if ($placedOrderId) {
            $session
                ->setLastOrderId(null)
                ->setLastRealOrderId(null);

            $this->messageManager->addErrorMessage(__('Payment expired'));
        }

        return $this->_redirect('checkout/cart');
    }
}
