<?php

declare(strict_types=1);

namespace Evidente\Aircash\Controller\Checkout;

use Magento\Checkout\Model\SessionFactory;
use Magento\Checkout\Model\Session;
use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\ActionInterface;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\View\Result\Page;

/**
 * @SuppressWarnings(Long)
 */
class Payment extends Action implements ActionInterface
{
    /**
     * @var SessionFactory
     */
    private $sessionFactory;

    /**
     * @inheritDoc
     */
    public function __construct(Context $context, SessionFactory $sessionFactory)
    {
        parent::__construct($context);
        $this->sessionFactory = $sessionFactory;
    }

    /**
     * @inheritDoc
     */
    public function execute()
    {
        /**
         * @var Session
         */
        $session = $this->sessionFactory->create();

        if (empty($session->getLastOrderId())) {
            return $this->resultRedirectFactory->create()->setPath('checkout/cart');
        }

        /** @var Page $resultPage */
        $resultPage = $this->resultFactory->create(ResultFactory::TYPE_PAGE);

        $resultPage
            ->getConfig()
            ->getTitle()
            ->set(__('Aircash Payment'));

        return $resultPage;
    }
}
