<?php

declare(strict_types=1);

namespace Evidente\Aircash\Data\Transaction;

use Evidente\Aircash\Api\Data\Transaction\CancellationRequestInterface;

class CancellationRequest implements CancellationRequestInterface
{
    private $partnerID;
    private $partnerTransactionID;
    private $websiteId;

    public function __construct(
        string $partnerID,
        string $partnerTransactionID,
        int $websiteId
    ) {
        $this->partnerID = $partnerID;
        $this->partnerTransactionID = $partnerTransactionID;
        $this->websiteId = $websiteId;
    }

    /**
     * @inheritDoc
     */
    public function getPartnerID(): string
    {
        return $this->partnerID;
    }

    /**
     * @inheritDoc
     */
    public function getPartnerTransactionID(): string
    {
        return $this->partnerTransactionID;
    }

    /**
     * @inheritDoc
     */
    public function getWebsiteId(): int
    {
        return $this->websiteId;
    }

    public function toArray(): array
    {
        return [
            'PartnerID' => $this->getPartnerID(),
            'PartnerTransactionID' => $this->getPartnerTransactionID(),
        ];
    }
}
