<?php

declare(strict_types=1);

namespace Evidente\Aircash\Data\Transaction;

use Evidente\Aircash\Api\Data\Transaction\RefundResultInterface;

/**
 * @SuppressWarnings(Long)
 */
class RefundResult implements RefundResultInterface
{
    private $transactionID;
    private $partnerTransactionID;
    private $refundPartnerTransactionID;

    public function __construct(
        string $transactionID,
        string $partnerTransactionID,
        string $refundPartnerTransactionID
    ) {
        $this->transactionID = $transactionID;
        $this->partnerTransactionID = $partnerTransactionID;
        $this->refundPartnerTransactionID = $refundPartnerTransactionID;
    }

    /**
     * @inheritDoc
     */
    public function getTransactionID(): string
    {
        return $this->transactionID;
    }

    /**
     * @inheritDoc
     */
    public function getPartnerTransactionID(): string
    {
        return $this->partnerTransactionID;
    }

    /**
     * @inheritDoc
     */
    public function getRefundPartnerTransactionID(): string
    {
        return $this->refundPartnerTransactionID;
    }
}
