<?php

declare(strict_types=1);

namespace Evidente\Aircash\Factory;

use Evidente\Aircash\Api\SignatureStringFactoryInterface;

class SignatureStringFactory implements SignatureStringFactoryInterface
{
    public function createFromArray(array $input): string
    {
        $processedInput = [];

        // for signatures, keys MUST start with a capital letter
        foreach ($input as $key => $value) {
            $processedInput[ucfirst($key)] = $value;
        }

        $input = $processedInput;

        ksort($input);

        foreach (array_keys($input) as $key) {
            if ($key === 'Signature') {
                unset($input[$key]);
                continue;
            }

            $current = $input[$key];

            if (is_float($current)) {
                $values = explode('.', (string)$current);

                $newValue = $values[0];

                if (array_key_exists(1, $values)) {
                    $newValue .= '.' . ltrim($values[1], '0');
                }

                $input[$key] = (float)$newValue;
            }
        }

        $output = '';

        foreach ($input as $key => $value) {
            if ($output !== '') {
                $output .= '&';
            }

            $output .= $key . '=' . $value;
        }

        return $output;
    }
}
