<?php

declare(strict_types=1);

namespace Evidente\Aircash\Gateway\Command;

use Evidente\Aircash\Api\AircashClientInterface;
use Evidente\Aircash\Api\Factory\Transaction\CancellationRequestFactoryInterface;
use Evidente\Aircash\Api\Factory\Transaction\RefundRequestFactoryInterface;
use Magento\Payment\Gateway\CommandInterface;
use Psr\Log\LoggerInterface;

/**
 * @SuppressWarnings(Long)
 */
abstract class AbstractCommand implements CommandInterface
{
    /**
     * @var AircashClientInterface
     */
    protected $aircashClient;

    /**
     * @var CancellationRequestFactoryInterface
     */
    protected $cancellationRequestFactory;

    /**
     * @var RefundRequestFactoryInterface
     */
    protected $refundRequestFactory;

    /**
     * @var LoggerInterface
     */
    protected $logger;

    public function __construct(
        AircashClientInterface $aircashClient,
        CancellationRequestFactoryInterface $cancellationRequestFactory,
        RefundRequestFactoryInterface $refundRequestFactory,
        LoggerInterface $logger
    ) {
        $this->aircashClient = $aircashClient;
        $this->cancellationRequestFactory = $cancellationRequestFactory;
        $this->refundRequestFactory = $refundRequestFactory;
        $this->logger = $logger;
    }
}
