<?php

declare(strict_types=1);

namespace Evidente\Aircash\Gateway\Command;

use Magento\Payment\Gateway\Command\CommandException;
use Magento\Payment\Gateway\CommandInterface;
use Magento\Sales\Api\Data\OrderInterface;
use Magento\Sales\Api\Data\OrderPaymentInterface;

/**
 * @SuppressWarnings(Long)
 */
class Capture extends AbstractCommand implements CommandInterface
{
    /**
     * @inheritDoc
     */
    public function execute(array $commandSubject)
    {
        /**
         * @var OrderPaymentInterface $payment
         */
        $payment = $commandSubject['payment']->getPayment();

        /**
         * @var OrderInterface $order
         */
        $order = $payment->getOrder();

        if (!$payment->getCcTransId()) {
            $message = sprintf(
                'Transaction ID not found for order #%s',
                $order->getIncrementId()
            );

            $this->logger->critical($message);

            throw new CommandException(__($message));
        }

        $payment->setTransactionId($payment->getCcTransId());
        $payment->setIsTransactionClosed(1);

        return null;
    }
}
