<?php

declare(strict_types=1);

namespace Evidente\Aircash\Gateway\Command;

use InvalidArgumentException;
use Magento\Framework\DataObject;
use Magento\Payment\Gateway\CommandInterface;
use Magento\Payment\Gateway\Data\PaymentDataObjectInterface;
use Magento\Sales\Model\Order;
use Magento\Sales\Model\Order\Payment;

/**
 * @SuppressWarnings(Long)
 */
class Initialize implements CommandInterface
{
    /**
     * @inheritDoc
     */
    public function execute(array $commandSubject)
    {
        if (!isset($commandSubject['payment'])
            || !$commandSubject['payment'] instanceof PaymentDataObjectInterface
        ) {
            throw new InvalidArgumentException('Payment data object should be provided');
        }

        $payment = $commandSubject['payment']->getPayment();

        $payment->prependMessage(__('Redirected customer to CorvusPay payment gateway.'));

        /** @var Order $order */
        $order = $payment->getOrder();
        $order->setCustomerNoteNotify(false);

        /** @var DataObject $stateObject */
        $stateObject = $commandSubject['stateObject'];
        $stateObject->setState(Order::STATE_PENDING_PAYMENT);
        $stateObject->setStatus(Order::STATE_PENDING_PAYMENT);
        $stateObject->setIsNotified(false);
    }
}
