<?php

declare(strict_types=1);

namespace Evidente\Aircash\Gateway\Handler;

use Evidente\Aircash\Api\ConfigInterface;
use Magento\Payment\Gateway\Config\ValueHandlerInterface;

class TitleHandler implements ValueHandlerInterface
{
    public const DEFAULT_TITLE = 'Aircash';

    /**
     * @var ConfigInterface
     */
    private $config;

    public function __construct(ConfigInterface $config)
    {
        $this->config = $config;
    }

    /**
     * @param array $subject
     * @param int|string|null $storeId
     * @return mixed
     * @SuppressWarnings(UnusedFormalParameter);
     */
    public function handle(array $subject, $storeId = null)
    {
        $title = $this->config->getTitle($storeId);

        if (is_string($title) && trim($title)) {
            return $title;
        }

        return self::DEFAULT_TITLE;
    }
}
