<?php

declare(strict_types=1);

namespace Evidente\Aircash\Test\Unit\Block\Adminhtml\System\Config\Form;

use Evidente\Aircash\Block\Adminhtml\System\Config\Form\ActionButtonBlock;
use Evidente\Aircash\Block\Adminhtml\System\Config\Form\ActionButtonField;
use Evidente\Aircash\Test\Unit\Block\Adminhtml\AbstractBlockTest;
use Magento\Framework\Data\Form\Element\Text;
use PHPUnit\Framework\MockObject\MockObject;

class ActionButtonFieldTest extends AbstractBlockTest
{
    /**
     * @var Text|MockObject
     */
    private $element;

    /**
     * @var ActionButtonField|MockObject
     */
    private $subject;

    protected function setUp(): void
    {
        parent::setUp();
        $this->element = $this->createMock(Text::class);
        $this->subject = new ActionButtonField($this->context);
    }

    public function testRender()
    {
        // given
        $expectedResult = 'html';

        $this->block->method('toHtml')->willReturn($expectedResult);

        $this
            ->layout
            ->expects($this->once())
            ->method('createBlock')
            ->with(ActionButtonBlock::class)
            ->willReturn($this->block);

        // when, then
        $this->subject->render($this->element);
    }
}
