<?php

declare(strict_types=1);

namespace Evidente\Aircash\Test\Unit\Controller\Adminhtml\Activation;

use Evidente\Aircash\Controller\Adminhtml\Activation\Index;
use Magento\Backend\Model\View\Result\Page;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Exception\NotFoundException;
use Magento\Framework\View\Page\Config;
use Magento\Framework\View\Page\Title;
use PHPUnit\Framework\MockObject\MockObject;

/**
 * @SuppressWarnings(PHPMD)
 */
class IndexTest extends AbstractControllerTest
{
    /**
     * @var Page|MockObject
     */
    private $page;

    /**
     * @var Config|MockObject
     */
    private $config;

    /**
     * @var Title|MockObject
     */
    private $title;

    /**
     * @var Index
     */
    private $subject;

    protected function setUp(): void
    {
        parent::setUp();

        $this->page = $this->createMock(Page::class);
        $this->config = $this->createMock(Config::class);
        $this->title = $this->createMock(Title::class);

        $this->page->method('getConfig')->willReturn($this->config);
        $this->config->method('getTitle')->willReturn($this->title);

        $this->subject = new Index($this->context);
    }

    /**
     * @throws NotFoundException
     */
    public function testExecute()
    {
        // given
        $this
            ->resultFactory
            ->expects($this->once())
            ->method('create')
            ->with(ResultFactory::TYPE_PAGE)
            ->willReturn($this->page);

        // when, then
        $this->subject->execute();
    }
}
