<?php

declare(strict_types=1);

namespace Evidente\Aircash\Test\Unit\Data\Transaction;

use Evidente\Aircash\Api\Data\Transaction\CodeRequestInterface;
use Evidente\Aircash\Api\Data\Transaction\ConfirmationResultInterface;
use Evidente\Aircash\Data\Transaction\ConfirmationResult;
use PHPUnit\Framework\TestCase;

/**
 * @SuppressWarnings(PHPMD)
 */
class ConfirmationResultTest extends TestCase
{
    public function testData()
    {
        // given
        $expectedPartnerId = 'partner_id';
        $expectedCurrency = CodeRequestInterface::CURRENCY_MAPPING[CodeRequestInterface::CURRENCY_EUR];
        $expectedAmount = 5.00;
        $expectedPartnerTransactionId = 'transaction_id';
        $expectedAircashTransactionId = 'aircash_transaction_id';
        $expectedSignature = 'signature';

        $expectedInput = [
            ConfirmationResultInterface::FIELD_PARTNER_TRANSACTION_ID => $expectedPartnerTransactionId,
            ConfirmationResultInterface::FIELD_CURRENCY_ID => $expectedCurrency,
            ConfirmationResultInterface::FIELD_AMOUNT => $expectedAmount,
            ConfirmationResultInterface::FIELD_PARTNER_ID => $expectedPartnerId,
            ConfirmationResultInterface::FIELD_AIRCASH_TRANSACTION_ID => $expectedAircashTransactionId,
            ConfirmationResultInterface::FIELD_SIGNATURE => $expectedSignature,
        ];

        // when
        $model = new ConfirmationResult($expectedInput);

        // then
        $this->assertSame($expectedPartnerTransactionId, $model->getPartnerTransactionID());
        $this->assertSame($expectedCurrency, $model->getCurrencyID());
        $this->assertSame($expectedAmount, $model->getAmount());
        $this->assertSame($expectedPartnerId, $model->getPartnerID());
        $this->assertSame($expectedAircashTransactionId, $model->getAircashTransactionID());
        $this->assertSame($expectedSignature, $model->getSignature());
    }
}
