<?php

declare(strict_types=1);

namespace Evidente\Aircash\Test\Unit\Gateway\Handler;

use Evidente\Aircash\Api\ConfigInterface;
use Evidente\Aircash\Gateway\Handler\TitleHandler;
use PHPUnit\Framework\MockObject\MockObject;
use PHPUnit\Framework\TestCase;
use ReflectionException;

class TitleHandlerTest extends TestCase
{
    /**
     * @var ConfigInterface|MockObject
     */
    private $config;

    /**
     * @throws ReflectionException
     */
    protected function setUp(): void
    {
        $this->config = $this->createMock(ConfigInterface::class);
    }

    public function testHandle()
    {
        $subject = new TitleHandler($this->config);

        $this->assertSame(TitleHandler::DEFAULT_TITLE, $subject->handle([]));
    }
}
